"""
Written by Matteo Dunnhofer - 2019

Data transformer class
"""
import numpy as np
import torch
from torchvision import transforms
import utils as ut

class DataTransformer(object):
	"""
	Defines an object that is responsible to transform the
	example images

	img: numpy array
	"""
	
	def __init__(self, cfg):
		self.cfg = cfg
		#self.i = 0

	def preprocess_img(self, img, crop_bb):
		"""
		Args:
			img: a PIL image

		Returns:
			a processed image tensor
		"""
		#crop_bb = ut.get_crop_bb(crop_bb, 0, 0, 2)
		#self.i += 1
		#print(crop_bb)
		crop = ut.xywh2xyxy(crop_bb)
		img = img.crop(crop)
		#img.save(str(self.i)+'img.png')
		img = transforms.Resize((self.cfg.SIZE[0], self.cfg.SIZE[1]))(img)
		img = transforms.ToTensor()(img)
		img = transforms.Normalize(mean=[0.485, 0.456, 0.406], std=[0.229, 0.224, 0.225])(img)

		return img

	def preprocess_img2(self, img, crop_bb, size, i=0):
		"""
		Args:
			img: a PIL image

		Returns:
			a processed image tensor
		"""
		#crop_bb = ut.get_crop_bb(crop_bb, 0, 0, 2)
		self.i += 1
		crop = ut.xywh2xyxy(crop_bb)
		img = img.crop(crop)
		#img.save(str(i)+'_img.png')
		img = transforms.Resize((size[0], size[1]))(img)
		#img.save(str(i)+'_img.png')
		img = np.array(img, dtype=np.float32)
		img = img.transpose(2, 0, 1)
		img = img - 128
		img = torch.from_numpy(img)

		return img
